; This instrument is designed for playing chords.
; Coded by Hans Mikelson 11/15/97

sr=44100
kr=22050
ksmps=2
nchnls=2

; Strummer Instrument
         instr  1

idur     =      p3
iamp     =      p4
iroot    =      p5
ichord   =      p6
iwave    =      p7
ireps    =      p8
ienv     =      p9
iphase   =      1-p10
itemper  =      p11
icarr    =      1
imodu    =      3

kamp1    oscil   1, ireps/idur, ienv
ichd1    table   0, ichord
ipch1    =       iroot+ichd1/100
ifrac1   =       frac(ipch1)*100/12
ioct1    =       int(ifrac1)
istep1   =       frac(ifrac1)*12+.5
         print   ioct1, istep1
ifqc1    cps2pch int(iroot)+ioct1+istep1/100, -itemper
;                Amp    Fqc    Car    Mod    Index    Wave
asig1    foscil  kamp1, ifqc1, icarr, imodu, kamp1*4, iwave

kamp2    oscil   1, ireps/idur, ienv, iphase
ichd2    table   1, ichord
ipch2    =       iroot+ichd2/100
ifrac2   =       frac(ipch2)*100/12
ioct2    =       int(ifrac2)
istep2   =       frac(ifrac2)*12+.5
         print   ioct2, istep2
ifqc2    cps2pch int(iroot)+ioct2+istep2/100, -itemper
asig2    foscil  kamp2, ifqc2, icarr, imodu, kamp2*4, iwave

kamp3    oscil   1, ireps/idur, ienv, iphase*2
ichd3    table   2, ichord
ipch3    =       iroot+ichd3/100
ifrac3   =       frac(ipch3)*100/12
ioct3    =       int(ifrac3)
istep3   =       frac(ifrac3)*12+.5
         print   ioct3, istep3
ifqc3    cps2pch int(iroot)+ioct3+istep3/100, -itemper
asig3    foscil  kamp3, ifqc3, icarr, imodu, kamp3*4, iwave

kamp4    oscil   1, ireps/idur, ienv, iphase*3
ichd4    table   3, ichord
ipch4    =       iroot+ichd4/100
ifrac4   =       frac(ipch4)*100/12
ioct4    =       int(ifrac4)
istep4   =       frac(ifrac4)*12+.5
         print   ioct4, istep4
ifqc4    cps2pch int(iroot)+ioct4+istep4/100, -itemper
asig4    foscil  kamp4, ifqc4, icarr, imodu, kamp4*4, iwave

kdclick  linseg  0, .002, 1, p3-.004, 1, .002, 0
aout     =       (asig1+asig2+asig3+asig4)*kdclick
adel1    delay   aout, .01
         outs    aout*iamp, adel1*iamp

         endin

; Equal Temperament Test
         instr  2

idur     =      p3
iamp     =      p4
ipch     =      p5+.005
iwave    =      p6
ienv     =      p7
itemper  =      p8
icarr    =      1
imodu    =      3

kamp1    oscil   1, 1/idur, ienv
ifqc1    cps2pch ipch, -itemper
print    ipch, ifqc1

;                Amp    Fqc    Car    Mod    Index    Wave
asig1    foscil  kamp1, ifqc1, icarr, imodu, kamp1*4, iwave

aout     =       asig1
         outs    aout*iamp, aout*iamp

         endin

        ; Equal Temperament Test
         instr  3

idur     =      p3
iamp     =      p4
ipch     =      p5
iwave    =      p6
ienv     =      p7
itemper  =      p8
icarr    =      1
imodu    =      3

kamp1    oscil   1, 1/idur, ienv

;Pitch to Frequency--Well Tempered 
iibas   =        int(ipch)
ifrc    =        (ipch-int(ipch))*100
iintf   =        int(ifrc/12)
ibase   =        iibas+iintf-2
inote   =        int(ifrc-iintf*12+.5)
itwopwr ipow     2, ibase
iscale  table    inote, itemper
ifqc    =        8.072559*iscale*itwopwr

;                Amp    Fqc   Car    Mod    Index    Wave
asig1    foscil  kamp1, ifqc, icarr, imodu, kamp1*4, iwave

aout     =       asig1
         outs    aout*iamp, aout*iamp

         endin

; Strummer Instrument
         instr  4

idur     =      p3
iamp     =      p4
iroot    =      p5
ichord   =      p6
iwave    =      p7
ireps    =      p8
ienv     =      p9
iphase   =      1-p10
itemper  =      p11
icarr    =      1
imodu    =      3

;Pitch to Frequency--Well Tempered 
ichd1    table   0, ichord
iichd1  =        int(ichd1/12)
ibase   =        iroot+iichd1-2
inote   =        int(ichd1-iichd1*12+.5)
itwopwr ipow     2, ibase
iscale  table    inote, itemper
ifqc1   =        8.072559*iscale*itwopwr

kamp1    oscil  1, ireps/idur, ienv
ifqc1    cps2pch iroot+ichd1/100, 12
;                Amp    Fqc    Car    Mod    Index    Wave
asig1    foscil  kamp1, ifqc1, icarr, imodu, kamp1*4, iwave

kamp2    oscil   1, ireps/idur, ienv, iphase
ichd2    table   1, ichord
ifqc2    cps2pch iroot+ichd2/100, 12
asig2    foscil  kamp2, ifqc2, icarr, imodu, kamp2*4, iwave

kamp3    oscil   1, ireps/idur, ienv, iphase*2
ichd3    table   2, ichord
ifqc3    cps2pch iroot+ichd3/100, 12
asig3    foscil  kamp3, ifqc3, icarr, imodu, kamp3*4, iwave

kamp4    oscil   1, ireps/idur, ienv, iphase*3
ichd4    table   3, ichord
ifqc4    cps2pch iroot+ichd4/100, 12
asig4    foscil  kamp4, ifqc4, icarr, imodu, kamp4*4, iwave

aout     =       asig1+asig2+asig3+asig4
         outs    aout*iamp, aout*iamp

         endin


